Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.heuristic.selector.move.generic.chained
Class SubChainSwapMove

    java.lang.Object
      org.optaplanner.core.impl.heuristic.move.AbstractMove
          org.optaplanner.core.impl.heuristic.selector.move.generic.chained.SubChainSwapMove

All Implemented Interfaces:
  Move

    public class SubChainSwapMove

extends AbstractMove

Non-cacheable

Constructor Summary
`SubChainSwapMove(GenuineVariableDescriptor variableDescriptor, SubChain leftSubChain, SubChain rightSubChain)`

Method Summary
`Move` | `createUndoMove(ScoreDirector scoreDirector)` Called before the move is done, so the move can be evaluated and then be undone without resulting into a permanent change in the solution.
`void` | `doMove(ScoreDirector scoreDirector)` Does the Move and updates the `Solution` and its `ScoreDirector` accordingly.
`boolean` | `equals(Object o)`
`SubChain` | `getLeftSubChain()`
`Collection<? extends Object>` | `getPlanningEntities()` Returns all planning entities that are being changed by this move.
`Collection<? extends Object>` | `getPlanningValues()` Returns all planning values that entities are being assigned to by this move.
`SubChain` | `getRightSubChain()`
`String` | `getSimpleMoveTypeDescription()` Describes the move type for statistical purposes.
`int` | `hashCode()`
`boolean` | `isMoveDoable(ScoreDirector scoreDirector)` Called before a move is evaluated to decide whether the move can be done and evaluated.
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SubChainSwapMove

    public SubChainSwapMove(GenuineVariableDescriptor variableDescriptor,
                            SubChain leftSubChain,
                            SubChain rightSubChain)

Method Detail

### getLeftSubChain

    public SubChain getLeftSubChain()

### getRightSubChain

    public SubChain getRightSubChain()

### isMoveDoable

    public boolean isMoveDoable(ScoreDirector scoreDirector)

  Description copied from interface: `Move`
  Called before a move is evaluated to decide whether the move can be done and evaluated. A Move is not doable if:
  - Either doing it would change nothing in the `Solution`.
  - Either it's simply not possible to do (for example due to build-in hard constraints).

  It is recommended to keep this method implementation simple: do not use it in an attempt to satisfy normal hard and soft constraints.

  Although you could also filter out non-doable moves in for example the `MoveSelector` or `MoveListFactory`, this is not needed as the `Solver` will do it for you.

  Parameters:
    `scoreDirector` - the `ScoreDirector` not yet modified by the move.
  Returns:
    true if the move achieves a change in the solution and the move is possible to do on the solution.

### createUndoMove

    public Move createUndoMove(ScoreDirector scoreDirector)

  Description copied from interface: `Move`
  Called before the move is done, so the move can be evaluated and then be undone without resulting into a permanent change in the solution.

  Parameters:
    `scoreDirector` - the `ScoreDirector` not yet modified by the move.
  Returns:
    an undoMove which does the exact opposite of this move.

### doMove

    public void doMove(ScoreDirector scoreDirector)

  Description copied from interface: `Move`
  Does the Move and updates the `Solution` and its `ScoreDirector` accordingly. When the `Solution` is modified, the `ScoreDirector` should be correctly notified, otherwise later calculated `Score`s can be corrupted.

  Parameters:
    `scoreDirector` - never null, the `ScoreDirector` that needs to get notified of the changes.

### getSimpleMoveTypeDescription

    public String getSimpleMoveTypeDescription()

  Description copied from interface: `Move`
  Describes the move type for statistical purposes. For example "ChangeMove(Process.computer)". The format is not formalized. Never parse the `String` returned by this method.

  Specified by:
    `getSimpleMoveTypeDescription` in interface `Move`
  Overrides:
    `getSimpleMoveTypeDescription` in class `AbstractMove`
  Returns:
    never null

### getPlanningEntities

    public Collection<? extends Object> getPlanningEntities()

  Description copied from interface: `Move`
  Returns all planning entities that are being changed by this move. Required for `AcceptorType.ENTITY_TABU`.

  Duplicates entries in the returned `Collection` are best avoided. The returned `Collection` is recommended to be in a stable order. For example: use `List` or `LinkedHashSet`, but not `HashSet`.

  Returns:
    never null

### getPlanningValues

    public Collection<? extends Object> getPlanningValues()

  Description copied from interface: `Move`
  Returns all planning values that entities are being assigned to by this move. Required for `AcceptorType.VALUE_TABU`.

  Duplicates entries in the returned `Collection` are best avoided. The returned `Collection` is recommended to be in a stable order. For example: use `List` or `LinkedHashSet`, but not `HashSet`.

  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.2.0.Final
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2015 JBoss by Red Hat. All Rights Reserved.